
#pragma hdrstop

#include "s.h"
#include "stm.hpp"

#include "packets.hpp"
#include "parsepar.hpp"
#include <sys/types.h>
#include <sys/stat.h>

#define USEUNIT(co)

//---------------------------------------------------------------------------
USEUNIT("serverimp.cpp");
USEUNIT("packets.cpp");
//---------------------------------------------------------------------------
#pragma argsused
int main(int argc, char* const *argv)
{

	// command line, setsid
	
   	bool daemon = false;
   	
	try {
	
    	option long_options[] = {
    		{ "port", 1, 0, 'p' },
    		{ "daemon", 0, 0, 'd'}
    	};
    	
    	
    		
    		
    	word port = 7627;	
    	
    	
    	paramsparser pp(argc, argv, "dp:", long_options);
    	
    	foreach(paramsparser::itr, i, pp)
    		switch (**i) {
    			case 'p' :
    				port = atoi(i.arg());
    				break;
    			case 'd' :
    				daemon = true;
    				break;
    		}
    		
    	
    	if (daemon) {		
    		int pid = stm::checkerror(fork());
    		if (pid != 0)
 	    		return 0;
 	    		
    		stm::checkerror(setsid());
		umask(0);
    		
    		int fd = stm::checkerror(open("/var/log/dfpts.log", O_CREAT | O_APPEND | O_WRONLY));
    		
    		stm::checkerror(close(STDIN_FILENO));
    		stm::checkerror(close(STDOUT_FILENO));
    		stm::checkerror(close(STDERR_FILENO));
    		
    		dup2(fd, STDOUT_FILENO);
    		dup2(fd, STDERR_FILENO);    		
    		
    		cout << "Server started. \n";
    	
    	}
	
		
	

		fserver::server s(port);
		s.welcome = "Marcin Wudarczyk's Dumb File Transfer Protocol Server ver. 1.0 ready.";
		s.st()->sessiontimeout = 600; // seconds
		dftpserver::registerdftpprotocol(&s);

		s.serve();

	} catch (stm::std_error &e) {
		cerr << e.where() << " : " << e.what();
	} catch (std::exception &e) {
		cerr << e.what();
	} catch (...) {
	 	cerr << "Unknown error, exiting ...\n";
	}
	
	if (daemon)
	  	cout << "Server stopped. \n";
	

	return 0;
}
